// Generated by CoffeeScript 1.10.0
var bytes, compresser, plugins, through2, uglifyjs;

bytes = require('./bytes');

through2 = require('through2');

uglifyjs = require('uglify-js');

plugins = (require('gulp-load-plugins'))();

compresser = function(arg) {
  var cwd, detachSourcemap, mangle, outputBytes, ref;
  ref = arg != null ? arg : {}, cwd = ref.cwd, mangle = ref.mangle, detachSourcemap = ref.detachSourcemap, outputBytes = ref.outputBytes;
  if (cwd == null) {
    cwd = process.cwd();
  }
  if (outputBytes == null) {
    outputBytes = false;
  }
  if (mangle == null) {
    mangle = false;
  }
  if (detachSourcemap == null) {
    detachSourcemap = false;
  }
  return through2.obj(function(file, enc, next) {
    var mangleOptions, mangled, map, ref1, source, sourceMap, sourceMapInline, sourceMapRegexp;
    if (mangle) {
      source = file.contents.toString();
      mangleOptions = {
        mangle: true,
        compress: true,
        fromString: true
      };
      if (detachSourcemap) {
        sourceMapRegexp = /\/\/# sourceMappingURL=data:application\/json;base64,.+$/m;
        sourceMapInline = (ref1 = source.match(sourceMapRegexp)) != null ? ref1[0].split(',')[1] : void 0;
        sourceMap = JSON.parse((new Buffer(sourceMapInline, 'base64')).toString());
        mangleOptions.inSourceMap = sourceMap;
        mangleOptions.outSourceMap = file.path + '.map';
      }
    }
    if (mangle) {
      mangled = uglifyjs.minify(source, mangleOptions);
      file.contents = new Buffer(mangled.code);
      if (mangled.map) {
        map = new plugins.util.File({
          path: file.path + '.map',
          contents: new Buffer(mangled.map)
        });
      }
    }
    this.push(file);
    if (map) {
      this.push(map);
    }
    if (outputBytes) {
      console.log('Yield:');
      console.log('  ', bytes(file, process.cwd()));
      if (map) {
        console.log('  ', bytes(map, process.cwd()));
      }
    }
    return next();
  });
};

module.exports = compresser;
